
//
//Delarations and utilities for using CARDS.DLL
//

#define DLL 1

//Actions for CdtDrawExt
/* use in the draw field */
#define C_FACES		(0)
#define C_BACKS		(1)
#define C_INVERT	(2)

//Card Numbers
/* use in the card field 
   from 0 to 51    [Ace (club,diamond,heart,spade), Deuce, ... , King] */
	

//Card Backs
/* use in the card field
   CAUTION: when card > 53 then draw must be = 1 (C_BACKS) */
#define crosshatch = 53
#define weave1 = 54
#define weave2 = 55
#define robot = 56
#define flowers = 57
#define vine1 = 58
#define vine2 = 59
#define fish1 = 60
#define fish2 = 61
#define shells = 62
#define castle = 63
#define island = 64
#define cardhand = 65
#define UNUSED = 66
#define THE_X = 67
#define THE_O = 68

#if DLL
// BRUCE: START: Trying to fix cards.dll crash on startup
BOOL (WINAPI* CdtAnimate)(HDC hDC, int cardBack, int xOrg, int yOrg, int state);
BOOL (WINAPI* CdtDraw)(HDC, int, int, int, int, COLORREF);
BOOL (WINAPI* CdtDrawExt)(HDC hDC, int xOrg, int yOrg, int width, int height, int card, int draw, DWORD color);
BOOL (WINAPI* CdtInit)(int*, int*);
BOOL (WINAPI* CdtTerm)(void);

/*
typedef INT (*INITPROC)(int FAR *width, int FAR *height);
typedef INT (*DRAWPROC)(HDC hDC, int xOrg, int yOrg, int card, int draw, DWORD color);
typedef INT (*DRAWEXTPROC)(HDC hDC, int xOrg, int yOrg, int width, int height, int card, int draw, DWORD color);
typedef INT (*ANIMATEPROC)(HDC hDC, int cardBack, int xOrg, int yOrg, int state);
typedef INT (*TERMPROC)(VOID);
extern DRAWPROC	   CdtDraw;
extern DRAWEXTPROC CdtDrawExt;
*/
// BRUCE: END


/*-----------------------------------------------------------------------------
|    cdtInit
|
|        Initialize cards.dll -- called once at app boot time.
|
|    Arguments:
|        int FAR *pdxCard: returns card width
|        int FAR *pdyCard: returns card height
|
|    Returns:
|        TRUE if successful.
BOOL _declspec(dllexport) cdtInit(int FAR *pdxCard, int FAR *pdyCard);
-------------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------
|    cdtDraw
|
|        Draw a card
|
|    Arguments:
|        HDC hdc
|        int x: upper left corner of the card
|        int y: upper left corner of the card
|        int cd: card to draw (depends on md)
|        int md: mode
|           mdFaceUp:    draw face up card (cd in cdAClubs..cdKSpades)
|           mdFaceDown:  draw face down card (cd in cdFaceDown1..cdFaceDown12)
|           mdHilite:    draw face up card inversely
|           mdGhost:     draw a ghost card, cd ignored
|           mdRemove:    draw rectangle of background color at x,y
|           mdDeckX:     draw an X
|           mdDeckO:     draw an O
|        DWORD rgbBgnd: table background color (only required for mdGhost and
|                                                mdRemove)
|
|    Returns:
|        TRUE if successful
BOOL _declspec(dllexport) cdtDraw(HDC hdc, int x, int y, int cd, int md, DWORD rgbBgnd);
-----------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------
|    cdtDrawExt
|
|        Same as cdtDraw except will stretch the cards to an arbitray extent
|
|    Arguments:
|        HDC hdc
|        int x
|        int y
|        int dx
|        int dy
|        int cd
|        int md
|        DWORD rgbBgnd:
|
|    Returns:
|        TRUE if successful
BOOL _declspec(dllexport) cdtDrawExt(HDC hdc, int x, int y, int dx, int dy,
                                    int cd, int md, DWORD rgbBgnd);
-----------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------
|    cdtAnimate
|
|        Draws the animation on a card.  Four cards support animation:
|
|      cd         #frames    description
|   cdFaceDown3   4          robot meters
|   cdFaceDown10  2          bats flapping
|   cdFaceDown11  4          sun sticks tongue out
|   cdFaceDown12  4          cards running up and down sleave
|
|    Call cdtAnimate every 250 ms for proper animation speed.
|
|    Arguments:
|        HDC hdc
|        int cd    cdFaceDown3, cdFaceDown10, cdFaceDown11 or cdFaceDown12
|        int x:    upper left corner of card
|        int y
|        int ispr  sprite to draw (0..1 for cdFaceDown10, 0..3 for others)
|
|    Returns:
|       TRUE if successful
BOOL _declspec(dllexport) cdtAnimate(HDC hdc, int cd, int x, int y, int ispr);
-----------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------
|    cdtTerm
|
|        Call once at app termination
VOID _declspec(dllexport) cdtTerm(VOID);
-----------------------------------------------------------------------------*/

#else

INT cdtInit (INT *width, INT *height);
INT cdtDraw (HDC hDC, INT xOrg, INT yOrg, INT card, INT draw, INT color);
INT cdtDrawExt (HDC hDC, INT xOrg, INT yOrg, INT width, INT height, INT card, INT draw, INT color);
INT cdtAnimate (HDC hDC, INT cardBack, INT xOrg, INT yOrg, INT state);
INT cdtTerm (VOID);

#endif
